golang中的defer panic recover

HopingWhite · · 1195 次点击 · · 开始浏览    
这是一个创建于 的文章,其中的信息可能已经有所发展或是发生改变。

大家都知道golang里的panic相当于其他语言里的throw,而recover相当于其他语言里的cacth,可是由于golang的recover机制要求必须在defer的函数里才能执行catch panic

大概意思如下


func protect(g func()) {
	defer func() {
		log.Println("done")  // Println executes normally even if there is a panic
		if x := recover(); x != nil {
			log.Printf("run time panic: %v", x)
		}
	}()
	log.Println("start")
	g()
}

这似乎跟try catch没啥区别,但是如果我们想实现一个其他语言里的如下功能时,可就不一样了


int test() {
    try {
        doSomething();
    }
    catch {
        return 1
    }
    return 2
}

显然这个函数需要能够根据有没有异常发生来返回不同的值,这怎么办呢?

其实这个问题与recover以及panic没啥关系了,这个问题纯粹属于defer的问题了,也即能不能在defer的函数里修改当前函数的返回值,答案当然是肯定的了,你只需要给返回值命名就行了


func routine() (b bool) {
	defer func() {
		err := recover()
		if err != nil {
			fmt.Printf("err found\n")
			b = true
		}
	}()
	if rand.Int()%10 == 1 {
		panic("hello")
	}
	b = false
	return
}

但是大家往深里想一下的话,就会觉得这样实现也挺坑爹的了,比如,里面有两处panic的时候,怎么办呀?当然是有办法的了,只是比较丑陋而已,这里就不举例说明了。



本文来自:CSDN博客

感谢作者:HopingWhite

查看原文:golang中的defer panic recover

1195 次点击  
加入收藏 微博
暂无回复
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传